function [AAM fitted_shape train_shapes] = build_testfit()


addpath('..');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  TRAINING %%%%%%%%%%%%%%
training_files = dir('trainimages/*.jpg.mat');

for i=1:numel(training_files)
	load(sprintf('trainimages/%s', training_files(i).name));
	
	app = imread(sprintf('trainimages/%s', training_files(i).name(1:end-4)));
	
	% Map RGB colors to [0,1]
	appearances(:,:,:,i) = double(app) ./ 255;
	
	train_shapes(:,:,i) = xy2ij(annotations, size(app,1));
end

one_out = [1:size(train_shapes,3)];

%%%%%%%%%%%%%%%%%%%LOAD TEST %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
testing_files = dir('testimages/*.jpg');
%%%%%%%%%%%%%%%%%% TRAINING AAM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AAM = build_model_2d(train_shapes(:,:,one_out), appearances(:,:,:,one_out));


fprintf('\n******************************************************* 2D FITTING *******************************************************\n\n');
sprintf('Total No. of Test Images = %d', numel(testing_files));

for i=1:numel(testing_files)
    sprintf('\nFOR Test Image = %d', i);
    appear = imread(sprintf('testimages/%s', testing_files(i).name));
    test_app = double(appear) ./ 255;
    str= 'y';
    while str == 'y'

        
        init_shape = one_out(round(rand()*(numel(one_out) - 1) + 1));
        try
            [ fitted_shape(:,:,i) fitted_app(:,:,:,i) ] = fit_2d(AAM, train_shapes(:,:,init_shape) + repmat([-5 -5], [size(train_shapes, 1) 1 1]), test_app(:,:,:) , 20);

            figure(1)
            imshow(test_app(:,:,:,1));
            hold on;
            %triplot(AAM.shape_mesh, train_shapes(:,2,init_shape), train_shapes(:,1,init_shape), 'b');
            triplot(AAM.shape_mesh, fitted_shape(:,2,i), fitted_shape(:,1,i), 'r');
            hold off;

            pause;
        catch ME
        fprintf('Fitting diverged: %s\n', ME.message);
        end
        prompt = 'Do you want more? Y/N [Y]: ';
        str = input(prompt,'s');
        if isempty(str)
        str = 'n';
        end
    end
    
    shape = zeros(58,2,5);
    
    if(mod(i,5) == 0)
        for k=1:5
            s = ij2xy(fitted_shape(:,:,i-5+k), size(app,1));
            shape(:,:,k) = s;
        end
        
        annotation_path = sprintf('testimages/%s.mat',testing_files(i).name(1:end-8));
        save(annotation_path, 'shape');
    %annotations = ij2xy(fitted_shape(:,:,i), size(app,1));
    %annotation_path = sprintf('testimages/%s.mat',testing_files(i).name);
    %save(annotation_path, 'annotations');
    end
    
end
end
	
