function [fitted_app] = magnify_image(AAM, cur_shape)

    app = imread('trainimages/1 (1).jpg');
    image_data = double(app) ./ 255;
	% Number of points in the shape
	np = size(cur_shape, 1);
	
	% Number of colors
	nc = size(image_data, 3);
	
	% Size of the model
	modelh = size(AAM.warp_map, 1);
	modelw = size(AAM.warp_map, 2);
	
    % Error image, simply the difference between the warped image and A0
    error_img = reshape(pa_warp(AAM, cur_shape, image_data), [], 1) - AAM.A0;

    % Project the error image onto the appearance modes and use the resulting parameters
    % to build the reconstructed appearance
    fitted_app = reshape(AAM.A0 + AAM.A * (AAM.A' * error_img), [modelh modelw nc]);
    
end
		
	